#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <algorithm>
#define MAX 10000

using namespace std;

int cnt;//0
int lastshow[MAX];//i,-1
int sum;
int vis[MAX];

struct edge{   //a->b
    int to;    //b
    int pro;  //a
    int weight;//
}e[MAX];

void insert(){
    int a, b, weight;
    scanf("%d %d %d", &a, &b, &weight);
    e[cnt].to = b;
    e[cnt].pro = lastshow[a]; //a
    e[cnt].weight = weight;
    lastshow[a] = cnt ++; //lastshow
}

int dfs(int a){
    if(vis[a])
        return 0;
//    cout << endl << a << endl;
    vis[a] = 1;
    int ret = 0;
    int id = lastshow[a];
    while(id != -1){
        ret += e[id].weight;
//        cout << endl << e[id].weight << endl;
        ret += dfs(e[id].to);
        id = e[id].pro;
    }
    return ret;
}

int main(){
    int n, c, srch;
    int i, j, k;
    while(cin >> n >> c){
        cnt = 0;
        sum = 0;
        memset(vis, 0, sizeof(vis));
        for(i = 0; i < MAX; i ++){
            lastshow[i] = -1;
        }
        for(i = 0; i < c; i ++){
            insert();
        }
        //i
        while(~scanf("%d", &srch)){
            if(-1 == srch)
                break;
            int id = lastshow[srch];
            cout << "" << srch << ":"<<endl;
            while(id != -1){
                cout << e[id].to << " " << e[id].weight << endl;
                id = e[id].pro;
            }
        }
        cout << "" << dfs(0) << endl;
    }
    return 0;
}